import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
/**
 * Clase de la barra de menu del panel.
 * @author Luis Fuentes
 */
public class LabMenuBar extends JMenuBar {
    private JMenu menu;
    private JMenuItem menuItem;
    private boolean flag = true;
    private SelectListener selListener;
    /**
     * Implementacion de la barra de menu de opciones
     * @param iel eventos de insersion de objetos fisicos.
     * @param sl eventos de las opciones del simulador.
     */
    public LabMenuBar(InsertElementListener iel, SimulatorListener sl, SelectListener sel) {
      selListener = sel;
      menu = new JMenu ("Insert");
      add(menu);
      menuItem = new JMenuItem("Mass");
      menuItem.addActionListener(iel);
      menu.add(menuItem);
      menuItem = new JMenuItem("Spring");
      menuItem.addActionListener(iel);
      menu.add(menuItem);
      menuItem = new JMenuItem("Rubber Band");
      menuItem.addActionListener(iel);
      menu.add(menuItem);
      menu = new JMenu("Simulator");
      add(menu);
      menuItem = new JMenuItem("Start");
      menuItem.addActionListener(sl);
      menu.add(menuItem);
      menuItem = new JMenuItem("Stop");
      menuItem.addActionListener(sl);
      menu.add(menuItem);
      JMenu subMenu = new JMenu("Setting");
      menu.add(subMenu);
      menuItem = new JMenuItem("Delta t");
      menuItem.addActionListener(sl);
      subMenu.add(menuItem);
      menuItem = new JMenuItem("Refresh time");
      menuItem.addActionListener(sl);
      subMenu.add(menuItem);
      menuItem = new JMenuItem("Gravity");
      menuItem.addActionListener(sl);
      subMenu.add(menuItem);
      menuItem = new JMenuItem("Plot max time");
      menuItem.addActionListener(sl);
      subMenu.add(menuItem);
      menuItem = new JCheckBoxMenuItem("String Damping");
      menuItem.setToolTipText("Rubber band adopts a string model (high stiffness prefered)");
      ((JCheckBoxMenuItem)menuItem).setState(false);
      menuItem.addActionListener(sl);
      subMenu.add(menuItem);
      menu = new JMenu ("Select");
      menu.setToolTipText("Select mass to be plotted");
      menuItem = new JMenuItem("No mass yet");
      menuItem.setEnabled(false);
      menu.add(menuItem);
      add(menu);
   }
   /**
    * Agrega un bloque al menu al ser insertado.
    * @param block Bloque nuevo insterado.
    */
    public void newBlock(Block block){
        if (flag){
            menu.remove(menuItem);
            menuItem = new JMenuItem("From panel");
            menuItem.addActionListener(selListener);
            menuItem.setToolTipText("Click a mass on the panel to plot it");
            menu.add(menuItem);
            menu.addSeparator();
            flag = false;
        }
        menuItem = new JMenuItem(block.getDescription2());
        menuItem.addActionListener(selListener);
        menu.add(menuItem);
    }
}