import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
/**
 * Clase que implementa la ventana de consulta de multiples datos de los objetos fisicos a insertar.
 * @author Luis Fuentes / Benjamin Ginouves
 */
public class OptionPaneMultiple extends JFrame
{
    /**
     * Metodo para implementar la consulta de las variables de los elementos fisicos a insertar.
     * @param bsc arreglo de objetos fisicos.
     * @param element String elemento seleccionado del menu para agregar elementos fisicos.
     * @throws NumberFormatException
     */
	public OptionPaneMultiple(BlockSpringConfiguration bsc, String element, LabMenuBar menuBar) throws NumberFormatException
	{
            boolean flag = true;
            NumberFormatException error = new NumberFormatException("negative");
            while(flag){
                try {
                    if(element.equals("Mass")){
                        JTextField mass = new JTextField("1");
                        JTextField height = new JTextField("40");
                        JTextField width = new JTextField("40");
                        JCheckBox fixed = new JCheckBox("Fixed");
                        Object[] msg = {"Mass", mass, "Height", height, "Width", width , fixed};

                        JOptionPane op = new JOptionPane(msg,JOptionPane.CLOSED_OPTION,JOptionPane.OK_CANCEL_OPTION,	null,	null);
                        JDialog dialog = op.createDialog(this, "Values");
                        dialog.setVisible(true);

                        if(((Integer)op.getValue()).intValue() == JOptionPane.OK_OPTION){
                            if ( Float.parseFloat(mass.getText()) <= 0 || Float.parseFloat(width.getText()) <= 0 || Float.parseFloat(height.getText()) <= 0 ) throw (error);
                            Block block = (Block)bsc.add(new GBlock(Float.parseFloat(mass.getText()), new Vector2D(200f,200f), new Vector2D(),Float.parseFloat(width.getText()),Float.parseFloat(height.getText()), fixed.isSelected()));
                            flag = false;
                            menuBar.newBlock(block);
                        }
                        
                    }

                    if(element.equals("Spring")){
                        JTextField restLength = new JTextField("100");
                        JTextField stiffness = new JTextField("50");
                        Object[] msg = {"Rest Length", restLength, "Stiffness", stiffness};

                        JOptionPane op = new JOptionPane(msg,JOptionPane.CLOSED_OPTION,JOptionPane.OK_CANCEL_OPTION,	null,	null);
                        JDialog dialog = op.createDialog(this, "Values");
                        dialog.setVisible(true);

                        if(((Integer)op.getValue()).intValue() == JOptionPane.OK_OPTION){
                            if ( Float.parseFloat(restLength.getText()) <= 0 || Float.parseFloat(stiffness.getText()) < 0) throw (error);
                            bsc.add(new GSpring(Float.parseFloat(restLength.getText()),Float.parseFloat(stiffness.getText())));
                            flag = false;
                        }

                    }

                    if(element.equals("Rubber Band")){
                        JTextField restLength = new JTextField("100");
                        JTextField stiffness = new JTextField("50");
                        Object[] msg = {"Rest Length", restLength, "Stiffness", stiffness};

                        JOptionPane op = new JOptionPane(msg,JOptionPane.CLOSED_OPTION,JOptionPane.OK_CANCEL_OPTION,	null,	null);
                        JDialog dialog = op.createDialog(this, "Values");
                        dialog.setVisible(true);

                        if(((Integer)op.getValue()).intValue() == JOptionPane.OK_OPTION){
                            if ( Float.parseFloat(restLength.getText()) <= 0) throw (error);
                            bsc.add(new GRubberBand(Float.parseFloat(restLength.getText()),Float.parseFloat(stiffness.getText())));
                            flag = false;
                        }

                    }

                    flag = false;
                }
                catch (NumberFormatException a){
                   JOptionPane.showMessageDialog(this, "Invalid input, please enter real positive numbers", "Error", 0);
                }
                catch (NullPointerException a){
                   flag = false;
                }
            }

        }

}